'\"
'\" Generated by tcllib/doctools/idx with format 'nroff'
.TH "Keyword Index" n
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH INDEX
tklib
.RS
2D geometry
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
alert
.RS
.TP
\fBfiles/modules/notifywindow/notifywindow\&.n\fR
notifywindow
.RE
append tag
.RS
.TP
\fBfiles/modules/canvas/canvas_tags\&.n\fR
canvas::tag
.RE
arc
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
arrow
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
background
.RS
.TP
\fBfiles/modules/canvas/canvas_gradient\&.n\fR
canvas::gradient
.RE
balloon
.RS
.TP
\fBfiles/modules/tooltip/tipstack\&.n\fR
tipstack
.TP
\fBfiles/modules/tooltip/tooltip\&.n\fR
tooltip
.RE
bindtags
.RS
.TP
\fBfiles/modules/ntext/ntext\&.n\fR
ntext
.TP
\fBfiles/modules/ntext/ntextBindings\&.n\fR
ntextBindings
.TP
\fBfiles/modules/ntext/ntextIndent\&.n\fR
ntextIndent
.TP
\fBfiles/modules/ntext/ntextWordBreak\&.n\fR
ntextWordBreak
.RE
bitmap
.RS
.TP
\fBfiles/apps/bitmap-editor\&.n\fR
bitmap-editor
.RE
box
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
bundle
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
calendar
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.TP
\fBfiles/modules/widget/widget_calendar\&.n\fR
widget_calendar
.RE
canvas
.RS
.TP
\fBfiles/modules/canvas/canvas_drag\&.n\fR
canvas::drag
.TP
\fBfiles/modules/canvas/canvas_ecircle\&.n\fR
canvas::edit::circle
.TP
\fBfiles/modules/canvas/canvas_epoints\&.n\fR
canvas::edit::points
.TP
\fBfiles/modules/canvas/canvas_epolyline\&.n\fR
canvas::edit::polyline
.TP
\fBfiles/modules/canvas/canvas_equad\&.n\fR
canvas::edit::quadrilateral
.TP
\fBfiles/modules/canvas/canvas_erectangle\&.n\fR
canvas::edit::rectangle
.TP
\fBfiles/modules/canvas/canvas_gradient\&.n\fR
canvas::gradient
.TP
\fBfiles/modules/canvas/canvas_highlight\&.n\fR
canvas::highlight
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.TP
\fBfiles/modules/canvas/canvas_snap\&.n\fR
canvas::snap
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.TP
\fBfiles/modules/canvas/canvas_tags\&.n\fR
canvas::tag
.TP
\fBfiles/modules/canvas/canvas_trlines\&.n\fR
canvas::track::lines
.TP
\fBfiles/modules/tkpiechart/canvaslabel\&.n\fR
canvasLabel
.TP
\fBfiles/modules/crosshair/crosshair\&.n\fR
crosshair
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.TP
\fBfiles/apps/diagram-viewer\&.n\fR
diagram-viewer
.TP
\fBfiles/modules/tkpiechart/pie\&.n\fR
pie
.TP
\fBfiles/modules/tkpiechart/pieboxlabeler\&.n\fR
pieBoxLabeler
.TP
\fBfiles/modules/tkpiechart/pieperipherallabeler\&.n\fR
piePeripheralLabeler
.RE
cell
.RS
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.RE
character
.RS
.TP
\fBfiles/modules/khim/khim\&.n\fR
khim
.RE
chat
.RS
.TP
\fBfiles/modules/chatwidget/chatwidget\&.n\fR
chatwidget
.RE
chatwidget
.RS
.TP
\fBfiles/modules/chatwidget/chatwidget\&.n\fR
chatwidget
.RE
circle
.RS
.TP
\fBfiles/modules/canvas/canvas_ecircle\&.n\fR
canvas::edit::circle
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
clock
.RS
.TP
\fBfiles/modules/datefield/datefield\&.n\fR
datefield
.RE
color gradient
.RS
.TP
\fBfiles/modules/canvas/canvas_gradient\&.n\fR
canvas::gradient
.RE
composite widget
.RS
.TP
\fBfiles/modules/chatwidget/chatwidget\&.n\fR
chatwidget
.RE
concave
.RS
.TP
\fBfiles/modules/canvas/canvas_equad\&.n\fR
canvas::edit::quadrilateral
.RE
controlling
.RS
.TP
\fBfiles/modules/controlwidget/controlwidget\&.n\fR
controlwidget
.RE
conversion
.RS
.TP
\fBfiles/apps/diagram-viewer\&.n\fR
diagram-viewer
.RE
convex
.RS
.TP
\fBfiles/modules/canvas/canvas_equad\&.n\fR
canvas::edit::quadrilateral
.RE
cross-hairs
.RS
.TP
\fBfiles/modules/crosshair/crosshair\&.n\fR
crosshair
.RE
crosshair
.RS
.TP
\fBfiles/modules/canvas/canvas_trlines\&.n\fR
canvas::track::lines
.RE
cursor
.RS
.TP
\fBfiles/modules/cursor/cursor\&.n\fR
cursor
.RE
data entry lists
.RS
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.TP
\fBfiles/modules/widgetl/widget_listsimple\&.n\fR
widget_listsimple
.RE
data entry ordered list
.RS
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.RE
data entry set of strings
.RS
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.TP
\fBfiles/modules/widgetl/widget_listsimple\&.n\fR
widget_listsimple
.RE
data entry unordered list
.RS
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.TP
\fBfiles/modules/widgetl/widget_listsimple\&.n\fR
widget_listsimple
.RE
date
.RS
.TP
\fBfiles/modules/datefield/datefield\&.n\fR
datefield
.TP
\fBfiles/modules/widget/widget_calendar\&.n\fR
widget_calendar
.TP
\fBfiles/modules/widget/widget_dateentry\&.n\fR
widget_dateentry
.RE
dateentry
.RS
.TP
\fBfiles/modules/datefield/datefield\&.n\fR
datefield
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.TP
\fBfiles/modules/widget/widget_dateentry\&.n\fR
widget_dateentry
.RE
diagram
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.TP
\fBfiles/apps/diagram-viewer\&.n\fR
diagram-viewer
.RE
dialog
.RS
.TP
\fBfiles/modules/getstring/tk_getString\&.n\fR
getstring
.TP
\fBfiles/modules/swaplist/swaplist\&.n\fR
swaplist
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
diamond
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
disjointlistbox
.RS
.TP
\fBfiles/modules/swaplist/swaplist\&.n\fR
swaplist
.RE
displaying
.RS
.TP
\fBfiles/modules/controlwidget/controlwidget\&.n\fR
controlwidget
.RE
dll
.RS
.TP
\fBfiles/modules/ico/ico\&.n\fR
ico
.RE
doctools
.RS
.TP
\fBfiles/apps/shtmlview\&.n\fR
shtmlview
.TP
\fBfiles/modules/shtmlview/shtmlview-doctools\&.n\fR
shtmlview_doctools
.RE
dragging
.RS
.TP
\fBfiles/modules/canvas/canvas_drag\&.n\fR
canvas::drag
.RE
drawing
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
drum
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
editing
.RS
.TP
\fBfiles/modules/canvas/canvas_ecircle\&.n\fR
canvas::edit::circle
.TP
\fBfiles/modules/canvas/canvas_epoints\&.n\fR
canvas::edit::points
.TP
\fBfiles/modules/canvas/canvas_epolyline\&.n\fR
canvas::edit::polyline
.TP
\fBfiles/modules/canvas/canvas_equad\&.n\fR
canvas::edit::quadrilateral
.TP
\fBfiles/modules/canvas/canvas_erectangle\&.n\fR
canvas::edit::rectangle
.RE
editor
.RS
.TP
\fBfiles/apps/bitmap-editor\&.n\fR
bitmap-editor
.RE
ellipse
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
enter callback
.RS
.TP
\fBfiles/modules/canvas/canvas_highlight\&.n\fR
canvas::highlight
.RE
entry
.RS
.TP
\fBfiles/modules/datefield/datefield\&.n\fR
datefield
.TP
\fBfiles/modules/getstring/tk_getString\&.n\fR
getstring
.TP
\fBfiles/modules/history/tklib_history\&.n\fR
history
.TP
\fBfiles/modules/ico/ico\&.n\fR
ico
.TP
\fBfiles/modules/ipentry/ipentry\&.n\fR
ipentry
.RE
exe
.RS
.TP
\fBfiles/modules/ico/ico\&.n\fR
ico
.RE
gradients
.RS
.TP
\fBfiles/modules/canvas/canvas_gradient\&.n\fR
canvas::gradient
.RE
graphics
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.RE
grid
.RS
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.RE
help
.RS
.TP
\fBfiles/modules/tooltip/tipstack\&.n\fR
tipstack
.TP
\fBfiles/modules/tooltip/tooltip\&.n\fR
tooltip
.RE
highlighting
.RS
.TP
\fBfiles/modules/canvas/canvas_highlight\&.n\fR
canvas::highlight
.RE
history
.RS
.TP
\fBfiles/modules/history/tklib_history\&.n\fR
history
.RE
hover
.RS
.TP
\fBfiles/modules/tooltip/tipstack\&.n\fR
tipstack
.TP
\fBfiles/modules/tooltip/tooltip\&.n\fR
tooltip
.RE
html
.RS
.TP
\fBfiles/modules/shtmlview/shtmlview\&.n\fR
shtmlview
.TP
\fBfiles/apps/shtmlview\&.n\fR
shtmlview
.TP
\fBfiles/modules/shtmlview/shtmlview-doctools\&.n\fR
shtmlview_doctools
.TP
\fBfiles/modules/shtmlview/shtmlview-mkdoc\&.n\fR
shtmlview_mkdoc
.RE
i18n
.RS
.TP
\fBfiles/modules/khim/khim\&.n\fR
khim
.RE
ico
.RS
.TP
\fBfiles/modules/ico/ico\&.n\fR
ico
.RE
icon
.RS
.TP
\fBfiles/modules/ico/ico\&.n\fR
ico
.RE
image
.RS
.TP
\fBfiles/apps/bitmap-editor\&.n\fR
bitmap-editor
.TP
\fBfiles/modules/canvas/canvas_gradient\&.n\fR
canvas::gradient
.TP
\fBfiles/modules/canvas/canvas_snap\&.n\fR
canvas::snap
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
imagemagick
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.RE
input
.RS
.TP
\fBfiles/modules/khim/khim\&.n\fR
khim
.RE
insert tag
.RS
.TP
\fBfiles/modules/canvas/canvas_tags\&.n\fR
canvas::tag
.RE
international
.RS
.TP
\fBfiles/modules/khim/khim\&.n\fR
khim
.RE
interpolation
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
intersection
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
invalid
.RS
.TP
\fBfiles/modules/widgetv/widget_validator\&.n\fR
widget_validator
.RE
ip address
.RS
.TP
\fBfiles/modules/ipentry/ipentry\&.n\fR
ipentry
.RE
irc
.RS
.TP
\fBfiles/modules/chatwidget/chatwidget\&.n\fR
chatwidget
.RE
labeler
.RS
.TP
\fBfiles/modules/tkpiechart/canvaslabel\&.n\fR
canvasLabel
.TP
\fBfiles/modules/tkpiechart/pie\&.n\fR
pie
.TP
\fBfiles/modules/tkpiechart/pieboxlabeler\&.n\fR
pieBoxLabeler
.TP
\fBfiles/modules/tkpiechart/pieperipherallabeler\&.n\fR
piePeripheralLabeler
.RE
leave callback
.RS
.TP
\fBfiles/modules/canvas/canvas_highlight\&.n\fR
canvas::highlight
.RE
line
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
list entry panel
.RS
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.TP
\fBfiles/modules/widgetl/widget_listsimple\&.n\fR
widget_listsimple
.RE
listbox
.RS
.TP
\fBfiles/modules/swaplist/swaplist\&.n\fR
swaplist
.RE
location
.RS
.TP
\fBfiles/modules/crosshair/crosshair\&.n\fR
crosshair
.RE
magick vector graphics
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.RE
map
.RS
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.RE
markdown
.RS
.TP
\fBfiles/apps/shtmlview\&.n\fR
shtmlview
.RE
mega-widget
.RS
.TP
\fBfiles/modules/chatwidget/chatwidget\&.n\fR
chatwidget
.RE
megawidget
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.TP
\fBfiles/modules/widget/widget_calendar\&.n\fR
widget_calendar
.TP
\fBfiles/modules/widget/widget_dateentry\&.n\fR
widget_dateentry
.TP
\fBfiles/modules/widget/widget_toolbar\&.n\fR
widget_toolbar
.RE
menu
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
method
.RS
.TP
\fBfiles/modules/khim/khim\&.n\fR
khim
.RE
mkdoc
.RS
.TP
\fBfiles/apps/shtmlview\&.n\fR
shtmlview
.TP
\fBfiles/modules/shtmlview/shtmlview-mkdoc\&.n\fR
shtmlview_mkdoc
.RE
move
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
mvg
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.RE
network
.RS
.TP
\fBfiles/modules/ipentry/ipentry\&.n\fR
ipentry
.RE
non-convex
.RS
.TP
\fBfiles/modules/canvas/canvas_equad\&.n\fR
canvas::edit::quadrilateral
.RE
notification
.RS
.TP
\fBfiles/modules/notifywindow/notifywindow\&.n\fR
notifywindow
.RE
numerical values
.RS
.TP
\fBfiles/modules/controlwidget/controlwidget\&.n\fR
controlwidget
.RE
panelframe
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
pdf
.RS
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.RE
photo
.RS
.TP
\fBfiles/modules/canvas/canvas_snap\&.n\fR
canvas::snap
.RE
picture
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
pie
.RS
.TP
\fBfiles/modules/tkpiechart/canvaslabel\&.n\fR
canvasLabel
.TP
\fBfiles/modules/tkpiechart/pie\&.n\fR
pie
.TP
\fBfiles/modules/tkpiechart/pieboxlabeler\&.n\fR
pieBoxLabeler
.TP
\fBfiles/modules/tkpiechart/pieperipherallabeler\&.n\fR
piePeripheralLabeler
.RE
pixel
.RS
.TP
\fBfiles/apps/bitmap-editor\&.n\fR
bitmap-editor
.RE
plane geometry
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
plotting
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
point
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
point cloud
.RS
.TP
\fBfiles/modules/canvas/canvas_epoints\&.n\fR
canvas::edit::points
.RE
points
.RS
.TP
\fBfiles/modules/canvas/canvas_epoints\&.n\fR
canvas::edit::points
.RE
polyline
.RS
.TP
\fBfiles/modules/canvas/canvas_epolyline\&.n\fR
canvas::edit::polyline
.RE
portable document format
.RS
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.RE
print screen
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.TP
\fBfiles/modules/canvas/canvas_snap\&.n\fR
canvas::snap
.RE
quadrilateral
.RS
.TP
\fBfiles/modules/canvas/canvas_equad\&.n\fR
canvas::edit::quadrilateral
.RE
raster image
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
re_syntax
.RS
.TP
\fBfiles/modules/ntext/ntext\&.n\fR
ntext
.TP
\fBfiles/modules/ntext/ntextIndent\&.n\fR
ntextIndent
.TP
\fBfiles/modules/ntext/ntextWordBreak\&.n\fR
ntextWordBreak
.RE
rectangle
.RS
.TP
\fBfiles/modules/canvas/canvas_erectangle\&.n\fR
canvas::edit::rectangle
.RE
regexp
.RS
.TP
\fBfiles/modules/ntext/ntext\&.n\fR
ntext
.TP
\fBfiles/modules/ntext/ntextIndent\&.n\fR
ntextIndent
.TP
\fBfiles/modules/ntext/ntextWordBreak\&.n\fR
ntextWordBreak
.RE
remove tag
.RS
.TP
\fBfiles/modules/canvas/canvas_tags\&.n\fR
canvas::tag
.RE
rubberband
.RS
.TP
\fBfiles/modules/canvas/canvas_trlines\&.n\fR
canvas::track::lines
.RE
ruler
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
scale widget
.RS
.TP
\fBfiles/modules/controlwidget/controlwidget\&.n\fR
controlwidget
.RE
screenruler
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
scroll
.RS
.TP
\fBfiles/modules/autoscroll/autoscroll\&.n\fR
autoscroll
.RE
scrollbar
.RS
.TP
\fBfiles/modules/autoscroll/autoscroll\&.n\fR
autoscroll
.RE
scrolledwindow
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
serialization
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.RE
set entry panel
.RS
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.TP
\fBfiles/modules/widgetl/widget_listsimple\&.n\fR
widget_listsimple
.RE
slice
.RS
.TP
\fBfiles/modules/tkpiechart/canvaslabel\&.n\fR
canvasLabel
.TP
\fBfiles/modules/tkpiechart/pie\&.n\fR
pie
.TP
\fBfiles/modules/tkpiechart/pieboxlabeler\&.n\fR
pieBoxLabeler
.TP
\fBfiles/modules/tkpiechart/pieperipherallabeler\&.n\fR
piePeripheralLabeler
.RE
snapshot
.RS
.TP
\fBfiles/modules/canvas/canvas_snap\&.n\fR
canvas::snap
.RE
snit
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.TP
\fBfiles/modules/widget/widget_calendar\&.n\fR
widget_calendar
.TP
\fBfiles/modules/widget/widget_dateentry\&.n\fR
widget_dateentry
.TP
\fBfiles/modules/widget/widget_toolbar\&.n\fR
widget_toolbar
.RE
spline
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.RE
square map
.RS
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.RE
state management
.RS
.TP
\fBfiles/modules/widgetv/widget_validator\&.n\fR
widget_validator
.RE
statusbar
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
string
.RS
.TP
\fBfiles/modules/getstring/tk_getString\&.n\fR
getstring
.RE
superframe
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.RE
syntax highlighting
.RS
.TP
\fBfiles/modules/ctext/ctext\&.n\fR
ctext
.RE
tags
.RS
.TP
\fBfiles/modules/canvas/canvas_tags\&.n\fR
canvas::tag
.RE
text
.RS
.TP
\fBfiles/modules/ctext/ctext\&.n\fR
ctext
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.TP
\fBfiles/modules/ntext/ntext\&.n\fR
ntext
.TP
\fBfiles/modules/ntext/ntextBindings\&.n\fR
ntextBindings
.TP
\fBfiles/modules/ntext/ntextIndent\&.n\fR
ntextIndent
.TP
\fBfiles/modules/ntext/ntextWordBreak\&.n\fR
ntextWordBreak
.TP
\fBfiles/modules/shtmlview/shtmlview\&.n\fR
shtmlview
.RE
tile
.RS
.TP
\fBfiles/modules/canvas/canvas_sqmap\&.n\fR
canvas::sqmap
.RE
tipstack
.RS
.TP
\fBfiles/modules/tooltip/tipstack\&.n\fR
tipstack
.RE
tk
.RS
.TP
\fBfiles/modules/notifywindow/notifywindow\&.n\fR
notifywindow
.RE
toolbar
.RS
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.TP
\fBfiles/modules/widget/widget_toolbar\&.n\fR
widget_toolbar
.RE
tooltip
.RS
.TP
\fBfiles/modules/tooltip/tooltip\&.n\fR
tooltip
.RE
tracking
.RS
.TP
\fBfiles/modules/canvas/canvas_trlines\&.n\fR
canvas::track::lines
.TP
\fBfiles/modules/crosshair/crosshair\&.n\fR
crosshair
.RE
ttk::combobox
.RS
.TP
\fBfiles/modules/widgetv/widget_validator\&.n\fR
widget_validator
.RE
ttk::entry
.RS
.TP
\fBfiles/modules/widgetv/widget_validator\&.n\fR
widget_validator
.RE
validation
.RS
.TP
\fBfiles/modules/widgetv/widget_validator\&.n\fR
widget_validator
.RE
vector
.RS
.TP
\fBfiles/modules/diagrams/diagram\&.n\fR
diagram
.TP
\fBfiles/apps/diagram-viewer\&.n\fR
diagram-viewer
.RE
vector graphics
.RS
.TP
\fBfiles/modules/canvas/canvas_mvg\&.n\fR
canvas::mvg
.TP
\fBfiles/modules/canvas/canvas_pdf\&.n\fR
canvas::pdf
.RE
viewer
.RS
.TP
\fBfiles/apps/shtmlview\&.n\fR
shtmlview
.RE
viewport
.RS
.TP
\fBfiles/modules/crosshair/crosshair\&.n\fR
crosshair
.RE
widget
.RS
.TP
\fBfiles/modules/chatwidget/chatwidget\&.n\fR
chatwidget
.TP
\fBfiles/modules/ctext/ctext\&.n\fR
ctext
.TP
\fBfiles/modules/datefield/datefield\&.n\fR
datefield
.TP
\fBfiles/modules/shtmlview/shtmlview\&.n\fR
shtmlview
.TP
\fBfiles/modules/widget/widget\&.n\fR
widget
.TP
\fBfiles/modules/widget/widget_calendar\&.n\fR
widget_calendar
.TP
\fBfiles/modules/widget/widget_dateentry\&.n\fR
widget_dateentry
.TP
\fBfiles/modules/widgetl/widget_listentry\&.n\fR
widget_listentry
.TP
\fBfiles/modules/widgetl/widget_listsimple\&.n\fR
widget_listsimple
.TP
\fBfiles/modules/widget/widget_toolbar\&.n\fR
widget_toolbar
.RE
widget background
.RS
.TP
\fBfiles/modules/canvas/canvas_gradient\&.n\fR
canvas::gradient
.RE
widget validation
.RS
.TP
\fBfiles/modules/widgetv/widget_validator\&.n\fR
widget_validator
.RE
xbm
.RS
.TP
\fBfiles/apps/bitmap-editor\&.n\fR
bitmap-editor
.RE
zoom
.RS
.TP
\fBfiles/modules/canvas/canvas_zoom\&.n\fR
canvas::zoom
.RE
.RE
