'\"
'\" Generated by tcllib/doctools/toc with format 'nroff'
.TH "Table Of Contents" n
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH CONTENTS
tklib
.RS
.TP
\fBautoscroll\fR
\fIfiles/modules/autoscroll/autoscroll\&.n\fR: Provides for a scrollbar to automatically mapped and unmapped as needed
.TP
\fBbitmap-editor\fR
\fIfiles/apps/bitmap-editor\&.n\fR: Editor for XBM images
.TP
\fBcanvas::drag\fR
\fIfiles/modules/canvas/canvas_drag\&.n\fR: Manage the dragging of canvas items or item groups
.TP
\fBcanvas::edit::circle\fR
\fIfiles/modules/canvas/canvas_ecircle\&.n\fR: Editing a circle on a canvas
.TP
\fBcanvas::edit::points\fR
\fIfiles/modules/canvas/canvas_epoints\&.n\fR: Editing a cloud of points on a canvas
.TP
\fBcanvas::edit::polyline\fR
\fIfiles/modules/canvas/canvas_epolyline\&.n\fR: Editing a polyline on a canvas
.TP
\fBcanvas::edit::quadrilateral\fR
\fIfiles/modules/canvas/canvas_equad\&.n\fR: Editing a quadrilateral on a canvas
.TP
\fBcanvas::edit::rectangle\fR
\fIfiles/modules/canvas/canvas_erectangle\&.n\fR: Editing a rectangle on a canvas
.TP
\fBcanvas::gradient\fR
\fIfiles/modules/canvas/canvas_gradient\&.n\fR: Canvas with a gradient background
.TP
\fBcanvas::highlight\fR
\fIfiles/modules/canvas/canvas_highlight\&.n\fR: Manage the highlighting of canvas items or item groups
.TP
\fBcanvas::mvg\fR
\fIfiles/modules/canvas/canvas_mvg\&.n\fR: Canvas to ImageMagick MVG vector format
.TP
\fBcanvas::pdf\fR
\fIfiles/modules/canvas/canvas_pdf\&.n\fR: Canvas to PDF
.TP
\fBcanvas::snap\fR
\fIfiles/modules/canvas/canvas_snap\&.n\fR: Canvas snapshot to Tk photo image
.TP
\fBcanvas::sqmap\fR
\fIfiles/modules/canvas/canvas_sqmap\&.n\fR: Canvas with map background based on square tiles
.TP
\fBcanvas::tag\fR
\fIfiles/modules/canvas/canvas_tags\&.n\fR: Easier management of the tags on canvas items or item groups
.TP
\fBcanvas::track::lines\fR
\fIfiles/modules/canvas/canvas_trlines\&.n\fR: Manage a group of rubber band lines
.TP
\fBcanvas::zoom\fR
\fIfiles/modules/canvas/canvas_zoom\&.n\fR: Zoom control for canvas::sqmap
.TP
\fBcanvasLabel\fR
\fIfiles/modules/tkpiechart/canvaslabel\&.n\fR: tkpiechart canvas label class
.TP
\fBchatwidget\fR
\fIfiles/modules/chatwidget/chatwidget\&.n\fR: Provides a multi-paned view suitable for display of chat room or irc channel information
.TP
\fBcontrolwidget\fR
\fIfiles/modules/controlwidget/controlwidget\&.n\fR: Collection of widgets for displaying and controlling numerical values
.TP
\fBcrosshair\fR
\fIfiles/modules/crosshair/crosshair\&.n\fR: Crosshairs for Tk canvas
.TP
\fBctext\fR
\fIfiles/modules/ctext/ctext\&.n\fR: Ctext a text widget with highlighting support
.TP
\fBcursor\fR
\fIfiles/modules/cursor/cursor\&.n\fR: Procedures to handle CURSOR data
.TP
\fBdatefield\fR
\fIfiles/modules/datefield/datefield\&.n\fR: Tk datefield widget
.TP
\fBdiagram\fR
\fIfiles/modules/diagrams/diagram\&.n\fR: Diagram drawing
.TP
\fBdiagram-viewer\fR
\fIfiles/apps/diagram-viewer\&.n\fR: Lightweight Diagram Processor
.TP
\fBgetstring\fR
\fIfiles/modules/getstring/tk_getString\&.n\fR: A string dialog
.TP
\fBhistory\fR
\fIfiles/modules/history/tklib_history\&.n\fR: Provides a history for Entry widgets
.TP
\fBico\fR
\fIfiles/modules/ico/ico\&.n\fR: Reading and writing windows icons
.TP
\fBipentry\fR
\fIfiles/modules/ipentry/ipentry\&.n\fR: An IP address entry widget
.TP
\fBkhim\fR
\fIfiles/modules/khim/khim\&.n\fR: Provides key bindings for entering international characters on a keyboard that does not support them
.TP
\fBmenubar\fR
\fIfiles/modules/menubar/menubar\&.n\fR: Creates an instance of the  Class\&.
.TP
\fBnotifywindow\fR
\fIfiles/modules/notifywindow/notifywindow\&.n\fR: Provides unobtrusive window for alerts/notifications from Tk applications
.TP
\fBntext\fR
\fIfiles/modules/ntext/ntext\&.n\fR: Alternative Bindings for the Text Widget
.TP
\fBntextBindings\fR
\fIfiles/modules/ntext/ntextBindings\&.n\fR: Alternative Bindings for the Text Widget
.TP
\fBntextIndent\fR
\fIfiles/modules/ntext/ntextIndent\&.n\fR: ntext Indentation for the Text Widget
.TP
\fBntextWordBreak\fR
\fIfiles/modules/ntext/ntextWordBreak\&.n\fR: ntext Word Boundary Detection for the Text Widget
.TP
\fBpersistentSelection\fR
\fIfiles/modules/persistentSelection/persistentSelection\&.n\fR: Enhanced PRIMARY selection
.TP
\fBpie\fR
\fIfiles/modules/tkpiechart/pie\&.n\fR: 2D or 3D pie chart object in a canvas
.TP
\fBpieBoxLabeler\fR
\fIfiles/modules/tkpiechart/pieboxlabeler\&.n\fR: tkpiechart pie box style labeler class
.TP
\fBpiePeripheralLabeler\fR
\fIfiles/modules/tkpiechart/pieperipherallabeler\&.n\fR: tkpiechart pie peripheral style labeler class
.TP
\fBPlotchart\fR
\fIfiles/modules/plotchart/plotchart\&.n\fR: Simple plotting and charting package
.TP
\fBshtmlview\fR
\fIfiles/modules/shtmlview/shtmlview\&.n\fR: Extended Tcl/Tk text widget with basic support for rendering of HTML and Markdown
.TP
\fBshtmlview\fR
\fIfiles/apps/shtmlview\&.n\fR: Basic HTML and Markdown viewer application
.TP
\fBshtmlview_doctools\fR
\fIfiles/modules/shtmlview/shtmlview-doctools\&.n\fR: shtmlview extension adding support for doctools markup
.TP
\fBshtmlview_mkdoc\fR
\fIfiles/modules/shtmlview/shtmlview-mkdoc\&.n\fR: shtmlview extension adding support for mkdoc markup
.TP
\fBswaplist\fR
\fIfiles/modules/swaplist/swaplist\&.n\fR: A dialog which allows a user to move options between two lists
.TP
\fBtipstack\fR
\fIfiles/modules/tooltip/tipstack\&.n\fR: Stacked tooltips
.TP
\fBtooltip\fR
\fIfiles/modules/tooltip/tooltip\&.n\fR: Tooltip management
.TP
\fBwidget\fR
\fIfiles/modules/widget/widget\&.n\fR: Megawidget bundle
.TP
\fBwidget_calendar\fR
\fIfiles/modules/widget/widget_calendar\&.n\fR: Calendar Megawidget
.TP
\fBwidget_dateentry\fR
\fIfiles/modules/widget/widget_dateentry\&.n\fR: Date Entry Megawidget
.TP
\fBwidget_listentry\fR
\fIfiles/modules/widgetl/widget_listentry\&.n\fR: widget::listentry widget
.TP
\fBwidget_listsimple\fR
\fIfiles/modules/widgetl/widget_listsimple\&.n\fR: widget::listsimple widget
.TP
\fBwidget_toolbar\fR
\fIfiles/modules/widget/widget_toolbar\&.n\fR: Toolbar Megawidget
.TP
\fBwidget_validator\fR
\fIfiles/modules/widgetv/widget_validator\&.n\fR: widget::validator behaviour
.TP
\fBwidgetPlus\fR
\fIfiles/modules/widgetPlus/widgetPlus\&.n\fR: Enhanced Entry, Spinbox, and Combobox Widgets with Undo/Redo and other useful features
